<template>
  <div>
    <v-breadcrumbs v-if="showPath">
      <v-icon slot="divider">chevron_right</v-icon>
      <v-breadcrumbs-item
        v-for="bc in breadcrumbs"
        :key="bc.text"
        :append="true"
        :to="bc.to"
        :exact="true"
      >
        <span v-if="!bc.icon">
          {{ bc.text }}
        </span>
        <span v-else>
          <v-icon>storage</v-icon>
        </span>
                        
      </v-breadcrumbs-item>
    </v-breadcrumbs>

    <file-list-view 
      v-if="view.mode == 'list'" 
      :items="files"
      :select-file="selectFile"
      :select-directory="selectDirectory"
      :back="canGoBack"
      @go-to="goTo"
      @go-back="goBackToParent"
      @selection-change="selectionChange"
    />
  </div>
</template>

<script>

import endpoints from '@api/endpoints'
import FileListView from '@components/FileListViewNG'
import FileIconView from '@components/FileIconView'

export default {

	components: {
		FileListView,
		FileIconView
	},

	props: {
		storage: {
			type: String,
			default: 'local'
		},
		parent: {
			type: [String, Number],
			default: null
		},
		filter: {
			type: Object,
			default: () => {
				return {
					'filetype': '*',
					'filext': '.*'
				}
			}
		},
		directoryOnly: {
			type: Boolean,
			default: false
		},
		noDownload: {
			type: Boolean,
			default: false
		},
		noDelete: {
			type: Boolean,
			default: false
		},
		noActions: {
			type: Boolean,
			default: false
		},
		canChangeStorage: {
			type: Boolean,
			default: false
		},
		selectFile: {
			type: Boolean,
			default: false
		},
		selectDirectory: {
			type: Boolean,
			default: false
		},
		back: {
			type: Boolean,
			default: false
		},
		showPath: {
			type: Boolean,
			default: false
		}
	},

	data() {
		return {
			directory: {
				files: [],
				path: []
			},
			view: {
				mode: 'list'
			},
			current: {
				storage: this.storage,
				parent: this.parent
			}
		}
	},

	computed: {
		files() {

			// sort

			return this.directory.files
		},

		breadcrumbs() {
			var path = []

			path.push({
				text: 'ROOT',
				icon: true,
				disabled: false,
				to: ''
			})

			if(this.directory.path === undefined)
				return path

			this.directory.path.forEach( function(el) {
				path.push({
					text: el.name,
					disabled: false,
					to: ''
				})
			}, this)
			// ,this) makes 'this.' within foreach callback to be the same as
			// 'this.' outside of it, at the same time it allows path variable
			// to be updated outside of forEach scope

			if(this.directory.id != null) {
				path.push({
					text: this.directory.name,
					icon: false,
					disabled: false,
					to: ''
				})
			}

			return path
		},

		canGoBack() {
			return this.breadcrumbs.length > 1
		},
	},

	methods: {
		//
		showDeleteFile(file) {

		},

		downloadFile(file) {

		},
		//
		goTo(file) {
			console.log('go-to', file)
			if(file.is_directory == '1')
				this.current.parent = file.id
		},

		goBackToParent() {
			this.current.parent = this.directory.parent_id
		},

		selectionChange(items) {
			this.$emit('selection-change', items)
		}
	},

	api: {
		directory: {
			url() {
				if(this.current.parent)
					return endpoints.files_query_url
				else
					return endpoints.files_root_url
			},
			variables() {
				return {
					storage: this.current.storage,
					id: this.current.parent
				}
			},
		}
	},
}

</script>